#pass this a pkl file name, with associated E,A and V pkl files.  It will 
#convert it to spikes, voltage, excitatory and inhibitory values.
#Note the spikes assume it's a .1

import sys
import cPickle as pickle

def printPklSpikes(fileHeader):
        spikeFileName = fileHeader+".pkl"
        voltFileName = fileHeader+"V.pkl"
        exciteFileName = fileHeader+"E.pkl"
        inhibitFileName = fileHeader+"I.pkl"

        spikeFileHandle = open(spikeFileName)
        voltFileHandle = open(voltFileName)
        exciteFileHandle = open(exciteFileName)
        inhibitFileHandle = open(inhibitFileName)

        spikeNeoObj = pickle.load(spikeFileHandle)
        voltNeoObj = pickle.load(voltFileHandle)
        exciteNeoObj = pickle.load(exciteFileHandle)
        inhibitNeoObj = pickle.load(inhibitFileHandle)

        spikeSegments = spikeNeoObj.segments
        voltSegments = voltNeoObj.segments
        exciteSegments = exciteNeoObj.segments
        inhibitSegments = inhibitNeoObj.segments

        spikeSegment = spikeSegments[0]
        voltSegment = voltSegments[0]
        exciteSegment = exciteSegments[0]
        inhibitSegment = inhibitSegments[0]

        spikeTrains = spikeSegment.spiketrains
        neurons = len(spikeTrains)

        voltReadings = voltSegment.analogsignals[0]
        exciteReadings = exciteSegment.analogsignals[0]
        inhibitReadings = inhibitSegment.analogsignals[0]
        timeSteps = len(voltReadings)

        for neuronNum in range (0,neurons):
            nextSpikeTime = timeSteps + 1
            if (len(spikeTrains[neuronNum])>0):
                spikes = spikeTrains[neuronNum]
                numSpikes = len(spikes)
                currentSpikeNumber = 0
                nextSpikeTime = float(spikes[0])
                nextSpikeTime = int(nextSpikeTime*10)

            for time in range (0,timeSteps):
                neuronSpikedNow = False
                if (time == nextSpikeTime):
                        neuronSpikedNow = True
                        currentSpikeNumber = currentSpikeNumber + 1
                        #print currentSpikeNumber
                        if (currentSpikeNumber >= len(spikeTrains[neuronNum])):
                                nextSpikeTime = timeSteps + 1
                        else:
                                nextSpikeTime =float(spikes[currentSpikeNumber])
                                nextSpikeTime = int(nextSpikeTime*10)
                voltage = float(voltReadings[time][neuronNum]) 
                voltage = round(voltage,2)
                excite = float(exciteReadings[time][neuronNum]) 
                excite = round(excite,2)
                inhibit = float(inhibitReadings[time][neuronNum]) 
                print neuronNum, "\t",time, "\t",neuronSpikedNow, "\t",voltage, "\t",excite, "\t",inhibit
                    

#                print time, voltReadings[time]
        
        """
        for neuronNum in range (0,neurons):
            if (len(spikeTrains[neuronNum])>0):
                spikes = spikeTrains[neuronNum]
                for spike in range (0,len(spikes)):
                    print neuronNum, spikes[spike]
        """

        spikeFileHandle.close()
        voltFileHandle.close()


#--main
args = sys.argv
numberArgs = args.__len__()
if (numberArgs == 2):
    fileName = args[1]
else:
    fileName = "nestState0.pkl"

printPklSpikes(fileName)
    
