# This is the simple associative memory that we use in the paper. 
#
#
#
#
import sys

import numpy as np
import pyNN.nest as sim
import cPickle as pickle
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
from stableBumpClass import StableBump

#
def init():
    sim.setup(timestep=neal.DELAY,min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)

#--main
simName = "nest"
spinnVersion = -1
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
stableBump = StableBump(neal,fsa)

init()

neurons = 100
cellClass=sim.IF_cond_exp
cellParams=fsa.CELL_PARAMS
#.2 6
#.3 8
#.32 11
#.4 D
tempPop = stableBump.stableBump(neurons,cellClass,cellParams,1,10,0.32,0.08)
tempPop.record(['spikes','v','gsyn_exc','gsyn_inh'])

#TEST 
spikeSource = stableBump.createTwoInputs()
for inputTemp in range (10,13):
        stableBump.turnOnCellFromSpikeSource(spikeSource[0],tempPop,inputTemp)


neal.nealApplyProjections()
sim.run(300)
sim.end()

tempPopPkl = tempPop.write_data("paperData/popTemp.pkl")
tempPop.print_v("paperData/popTempV.pkl")
tempPop.write_data("paperData/popTempE.pkl",'gsyn_exc')
tempPop.write_data("paperData/popTempI.pkl",'gsyn_inh')


