# Stable Bump Class
#
#
import cPickle as pickle
import pyNN.nest as sim
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
import numpy as np
import sys

class StableBump:
	def __init__(self,NEAL,FSA):
		simName = "nest"
		spinnVersion = -1
		self.neal = NEAL
		self.fsa = FSA
	
        def makeStableBumpConnections(self,numNeurons,neurons,excitatoryWindow, 
                               inhibitoryWindow,exciteWeight,inhibWeight):
            exciteConnector = []
            inhibConnector = []

            for fromNeuron in range (0,numNeurons):
                longExciteWeight = 0.0 #0.02
                #exciteWeight = 0.1 #0.08
                #inhibWeight = 0.01 #0.08

                #before excite
                beforeExcite = fromNeuron-excitatoryWindow
                if (beforeExcite < 0): beforeExcite = 0
                for toNeuron in range(beforeExcite,fromNeuron):
                    exciteConnector = exciteConnector + [(fromNeuron,toNeuron,
                                        exciteWeight, self.neal.DELAY)]

                #after excite
                afterExcite = fromNeuron+excitatoryWindow+1
                if (afterExcite > numNeurons): afterExcite = numNeurons
                for toNeuron in range(fromNeuron+1,afterExcite):
                    exciteConnector = exciteConnector + [(fromNeuron,toNeuron,
                                        exciteWeight, self.neal.DELAY)]

                """
                #long excite 
                beforeExcite = toNeuron - (excitatoryWindow+inhibitoryWindow+6)
                if (beforeExcite >=0):
                        exciteConnector = exciteConnector+ [(fromNeuron,
                                beforeExcite,longExciteWeight, self.neal.DELAY)]
                afterExcite = toNeuron + (excitatoryWindow+inhibitoryWindow+6)
                if (afterExcite < numNeurons):
                        exciteConnector = exciteConnector+ [(fromNeuron,
                                afterExcite,longExciteWeight, self.neal.DELAY)]
                """

                #before inhib
                beforeInhibStart=fromNeuron-(excitatoryWindow+inhibitoryWindow)
                beforeInhibEnd=fromNeuron-(excitatoryWindow)
                if (beforeInhibStart < 0): beforeInhibStart = 0
                for toNeuron in range(beforeInhibStart,beforeInhibEnd):
                    inhibConnector = inhibConnector + [(fromNeuron,toNeuron,
                                        inhibWeight, self.neal.DELAY)]


                #after inhib
                afterInhibStart=fromNeuron+excitatoryWindow+1
                afterInhibEnd=fromNeuron+excitatoryWindow+inhibitoryWindow+1
                if (afterInhibEnd > numNeurons): afterInhibEnd = numNeurons
                for toNeuron in range(afterInhibStart,afterInhibEnd):
                    inhibConnector = inhibConnector + [(fromNeuron,toNeuron,
                                        inhibWeight, self.neal.DELAY)]

            #end from loop
            
            #print exciteConnector
            self.neal.nealProjection(neurons, neurons, exciteConnector,
                                         'excitatory')
            #print 'inhib',inhibConnector
            self.neal.nealProjection(neurons, neurons,inhibConnector,
                                         'inhibitory')

	
	def stableBump(self, numNeurons,cellclass,cellparams,exWindow,inWindow,
                exWeight,inhibWeight):

                excitatoryWindow = exWindow
                inhibitoryWindow = inWindow
		neurons = sim.Population(numNeurons, cellclass, cellparams)
                self.makeStableBumpConnections(numNeurons,neurons,
                        excitatoryWindow,inhibitoryWindow,exWeight,inhibWeight)
                return neurons
                                        
	def turnOnWindowFromSpikeSource(self,spikeSource,temp,tempID):
		conn = [(0,tempID,self.fsa.INPUT_WEIGHT,self.neal.DELAY)]
		connector = sim.FromListConnector(conn)
		projections = sim.Projection(spikeSource, temp, 
			connector, 
			sim.StaticSynapse(weight=0.5),
			'excitatory')
		return projections

	def createTwoInputs(self):
	    inputSpikeTimes0 = [10.0]
	    inputSpikeTimes1 = [50.0]
	    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
	    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
					   label='inputSpikes_0')
	    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
	    spikeGen1=sim.Population(1, sim.SpikeSourceArray, spikeArray1,
					   label='inputSpikes_1')

	    return [spikeGen0,spikeGen1]

	def printResults(self, simCells):
	    simCells.printSpikes('temp.pkl')

	def setupRecording(self, cells):
	    cells.record({'spikes','v'})

	def turnOnCellFromSpikeSource(self,spikeSource,pop,cellID):
		connector = [(0,cellID,self.fsa.INPUT_WEIGHT,self.neal.DELAY)]
	        self.neal.nealProjection(spikeSource,pop,connector,'excitatory')


	def stateHalfTurnsOnCell(self,fromNeurons,fromCA,pop,cellID):
		connector = []
        	#uses HALF_ON_WEIGHT
        	for fromOffset in range (0,self.fsa.CA_SIZE-self.fsa.CA_INHIBS):
            		fromNeuron = fromOffset + (fromCA*self.fsa.CA_SIZE)
            		connector=connector+[(fromNeuron,cellID,
				self.fsa.HALF_ON_WEIGHT,
                        	self.neal.DELAY)]

	        self.neal.nealProjection(fromNeurons,pop,connector,'excitatory')
